"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _DbmlExporter = _interopRequireDefault(require("./DbmlExporter"));

var _MysqlExporter = _interopRequireDefault(require("./MysqlExporter"));

var _PostgresExporter = _interopRequireDefault(require("./PostgresExporter"));

var _JsonExporter = _interopRequireDefault(require("./JsonExporter"));

var _SqlServerExporter = _interopRequireDefault(require("./SqlServerExporter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var ModelExporter = /*#__PURE__*/function () {
  function ModelExporter() {
    _classCallCheck(this, ModelExporter);
  }

  _createClass(ModelExporter, null, [{
    key: "export",
    value: function _export() {
      var model = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var format = arguments.length > 1 ? arguments[1] : undefined;
      var isNormalized = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var res = '';
      var normalizedModel = isNormalized ? model : model.normalize();

      switch (format) {
        case 'dbml':
          res = _DbmlExporter["default"]["export"](normalizedModel);
          break;

        case 'mysql':
          res = _MysqlExporter["default"]["export"](normalizedModel);
          break;

        case 'postgres':
          res = _PostgresExporter["default"]["export"](normalizedModel);
          break;

        case 'json':
          res = _JsonExporter["default"]["export"](model, isNormalized);
          break;

        case 'mssql':
          res = _SqlServerExporter["default"]["export"](normalizedModel);
          break;

        default:
          break;
      }

      return res;
    }
  }]);

  return ModelExporter;
}();

var _default = ModelExporter;
exports["default"] = _default;